﻿using System.Data.Entity.ModelConfiguration;
using System.ComponentModel.DataAnnotations;

namespace CodeFirst.DataAccess
{
    public class TripMap : EntityTypeConfiguration<CodeFirst.Model.Trip>
    {
        public TripMap()
        {
            this.HasKey(t => t.Identifier); //主键
            this.Property(t => t.Identifier).HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity); //Guid类型主键自增长
            this.Property(t => t.RowVersion).IsRowVersion();    //时间戳

            this.HasMany(t => t.Activities).WithMany(a => a.Trips).Map(m =>
            {
                m.ToTable("TripActivities");   //中间关系表表名
                m.MapLeftKey("TripIdentifier");   //Activity表在中间表的主键名
                m.MapRightKey("ActivityId");   //Trip表在中间表的主键名
            });
        }
    }
}
